version: '3.8'

services:
  scanpc_client:
    container_name: "scanpc_client"
    build:
      context: .
      dockerfile: dockerfiles/client/Dockerfile
      args:
        - SCANPC_ROOT=/usr/local/scanpc
        - CMAKE_MODULES_ROOT=/usr/local/share/cmake_modules
        - TIFFANY_ROOT=/usr/local/tiffany
        - TIFFANY_FILE_LOG_ROOT=/var/log/scanpc
        - PYTHON_ROOT=/usr/local/python
        - BEATBOT_ROOT=/usr/local/beatbot
    image: scanpc_client:1.0.0
    depends_on:
      - scanpc_beatbot_client
    env_file:
      - environments/beatbot.env
      - environments/scanpc_client.env
    environment:
      - HOST_LOCAL_IP=$HOST_LOCAL_IP
      - HOST_LOCAL_MAC_ADDRESS=$HOST_LOCAL_MAC_ADDRESS
    network_mode: "service:scanpc_beatbot_client" # Share same network interface
    volumes:
      - scanpc_client_log:/var/log/scanpc
      - /etc/group:/etc/group:ro
      - /etc/passwd:/etc/passwd:ro
      - /etc/shadow:/etc/shadow:ro
    command: bash -c "sleep 2 && scanpc --host $SERVER_HOST --port $SERVER_PORT client"
    
  scanpc_beatbot_client:
    container_name: "scanpc_beatbot_client"
    hostname: $HOSTNAME
    image: registry.gitlab.com/rl_pipeline/internal/beatbot:0.1.0-client
    restart: always
    env_file:
      - environments/beatbot.env
    # network_mode: host # Un-comment this if connecting client from same host
    networks: 
      - scanpcnet 
    volumes:
      - beatbot_client_log:/var/log/beatbot
    command: ["beatbot", "--host", $SERVER_HOST, "client"]

networks:
  scanpcnet:
    external: true

volumes:
  beatbot_client_log:
  scanpc_client_log: